"use strict";
this.name               = "hudselector";
this.author               = "Norby";
this.copyright            = "2014 Norby";
this.description         = "Change your HUD during flight between the supported ones.";
this.version            = "1.1";
this.licence     = "CC BY-NC-SA 4.0";


this.$HUDSelectorHUDs = [["Default HUD","hud","hud","hud","hud"], //name and .plists for the 4 views
//			["Your HUD","yourhud","yourhud-aft","yourhud-port","yourhud-starboard"], //insert your HUD here
			//original is a copy of the oolite's stock hud.plist but with 8 MFDs
			["Original HUD with 8 MFDs","hudselector-original", "hudselector-original",
			 "hudselector-original", "hudselector-original", ],
			 //copy of stock hud-small.plist but with 8 MFDs
			["Small HUD with 8 MFDs","hudselector-small","hudselector-small",
			 "hudselector-small","hudselector-small"]
			];

//default MFD 1-8 worldScript names
this.$HUDSelectorMFDs = [["combat_MFD"],
			["CommsLogMFD"],
			["BroadcastCommsMFD"],
			["trophy_col", "trophy_mfd"], //mfd name is different
			["navi_mfd"],
			["market_inquirer", "inquirer_mfd"], //mfd name is not equal with worldScript name
			["manifest_mfd"],
			["useful_MFDs", "useful_MFD_general_info"] //mfd name is different
			];

//internal properties, should not touch
this.$HUDSelectorDefaultMFDs = []; //load the default MFD settings into this array
this.$HUDSelectorChoice = null; //store the last selection in missionscreens
this.$HUDSelectorEqSel = 0; //number of the selected HUD
this.$HUDSelectorFCB = null; //FCB for missionscreen choices
this.$HUDSelectorFCB2 = null; //another FCB for MFD missionscreen choices
this.$HUDSelectorTimer = null; //store a 0.1s delay timer for other startUps

//equipment events
this.activated = function() {
	var h = worldScripts.hudselector;
	h.$HUDSelectorEqSel++; //select next HUD
	if( h.$HUDSelectorEqSel >= h.$HUDSelectorHUDs.length ) h.$HUDSelectorEqSel = 0;
	player.consoleMessage( h.$HUDSelectorHUDs[h.$HUDSelectorEqSel][0]+" selected", 10 );
	h.$HUDSelectorSetHUD(h);
}

this.mode = function() {
//	player.ship.takeInternalDamage();//debug!
}

//worldscript events
this.startUp = function() {
	this.$MFDsetup = true; //do once only after load game
	var d = missionVariables.$HUDSelectorDefaultMFDs;
	if( !d ) this.$HUDSelectorDefaultMFDs = [];
	else if( (d+"").indexOf(",") ) this.$HUDSelectorDefaultMFDs = (d+"").split(","); //need +"" for bugfix of a single item
	else this.$HUDSelectorDefaultMFDs = [d];
//	log(this.name, "DefaultMFDs: "+this.$HUDSelectorDefaultMFDs);//debug
	
	this.$HUDSelectorEqSel = 0; //number of the selected HUD
	this.$HUDSelectorTimer = new Timer(this, this.$HUDSelectorRestoreHUD.bind(this), 0.1, 0); //0.1s delay for other startUps

	if( player.ship && player.ship.docked ) this.shipDockedWithStation( player.ship.dockedStation ); //set interface
	else if( system ) this.shipDockedWithStation( system.mainStation );//fallback

}

this.startUpComplete = function() {
	if( !this.$HUDSelectorDefaultMFDs || !(this.$HUDSelectorDefaultMFDs.length > 0) ) {
		//set default MFDs first time in order of $HUDSelectorMFDs array
		this.$HUDSelectorDefaultMFDs = [];
		for(var i = 0; i < this.$HUDSelectorMFDs.length; i++) {
			if(this.$HUDSelectorMFDs[i] && this.$HUDSelectorMFDs[i][0]) {
				var w = this.$HUDSelectorMFDs[i][0]; //worldScript name
				if( worldScripts[w] ) {
					this.$HUDSelectorDefaultMFDs[i] = w;
				}
			}
		}
	}
//	log(this.name, "DefaultMFDs: "+this.$HUDSelectorDefaultMFDs);//debug
}

this.playerBoughtEquipment = function(equipmentKey) {
	if( equipmentKey == "EQ_HUDSELECTOR_REMOVE" ) {
		var eq = equipmentKey.substr( 0, equipmentKey.length-7 );//the real eq
		player.ship.removeEquipment( eq ); //remove it
		player.ship.removeEquipment( equipmentKey ); //remove the "bought" remove eq
	}
}

this.playerWillSaveGame = function(message) {
	missionVariables.$HUDSelectorHUD = this.$HUDSelectorHUDs[this.$HUDSelectorEqSel][1];
	missionVariables.$HUDSelectorDefaultMFDs = this.$HUDSelectorDefaultMFDs;  //store default MFDs
}

this.shipDockedWithStation = function(station)
{
	station.setInterface("HUD and MFD selector",{
		title: "HUD and MFD selector",
		category: "Ship Systems",
		summary: "Select your HUD and the default Multi-Function Displays.",
		callback: this.$HUDSelector_Interface.bind(this)
		});
}

this.shipWillLaunchFromStation = function() {
//	log(this.name, "MFDSetup: "+this.$MFDsetup);//debug
//	log(this.name, "DefaultMFDs: "+this.$HUDSelectorDefaultMFDs);//debug
	if(this.$MFDsetup) { //must setup MFDs here and not eralier in startup()
		this.$MFDsetup = false; //do only once after load game or MFD interface
		this.$HUDSelectorSetMFDs(this);
	}
}

//HUDSelector methods
this.$HUDSelectorAddHUD = function(hudname, hudplist) {
	worldScripts.hudselector.$HUDSelectorHUDs.push([hudname, hudplist]);
}

this.$HUDSelectorAddMFD = function(mfdworldscript, mfdname) {
	if(!mfdworldscript) return; //this one is really needed
	if(!mfdname) mfdname = mfdworldscript; //if the mfd name is missing then assume than equal with wsname

	var h = worldScripts.hudselector;
	var mfdin = false;
	for(var i = 0; i < h.$HUDSelectorMFDs.length; i++) {
		if(h.$HUDSelectorMFDs[i] && mfdworldscript == h.$HUDSelectorMFDs[i][0])
			mfdin = true;
	}
	if(!mfdin) h.$HUDSelectorMFDs.push([mfdworldscript, mfdname]);
}

this.$HUDSelectorRestoreHUD = function() { //call after all startUp finished where other worldScripts can add HUDs
	var h = worldScripts.hudselector;
	var hud = missionVariables.$HUDSelectorHUD; //restore saved HUD
	if( hud && hud.length > 0 ) {
		for( var i = 0; i < h.$HUDSelectorHUDs.length; i++ ) {
			if( h.$HUDSelectorHUDs[i][1] == hud ) {
				h.$HUDSelectorEqSel = i;
				h.$HUDSelectorSetHUD(w);
			}
		}
	}
}

this.$HUDSelectorSetHUD = function(h) {
	var p = h.$HUDSelectorHUDs[h.$HUDSelectorEqSel][1];
	for( var i = 0; i < h.$HUDSelectorHUDs.length; i++ ) { //call callback functions
		var off = true; //deactivate all HUDs
		if( i == h.$HUDSelectorEqSel ) off = false; //activate the selected one
		var wh = worldScripts[h.$HUDSelectorHUDs[i][1]];
		if( wh && wh.$HUDSelectorCallBack ) wh.$HUDSelectorCallBack( off );
		//if( wh ) wh += wh.$HUDSelectorCallBack; //debug
		//log("hudselector",i+". "+p+" "+wh); //debug
	}
	player.ship.hud =  p+".plist"; //set the selected HUD
	h.$HUDSelectorSetMFDs(h);
}

this.$HUDSelectorSetMFDs = function(h) {
	for(var i = 0; i < h.$HUDSelectorDefaultMFDs.length; i++) {
//	log(h.name, i+". MFD: "+h.$HUDSelectorDefaultMFDs[i]);//debug
		if(h.$HUDSelectorDefaultMFDs[i]) {
			var w = h.$HUDSelectorDefaultMFDs[i]; //worldScript name
			var mfd = -1;
			for(var j = 0; j < h.$HUDSelectorMFDs.length; j++) {
				if( h.$HUDSelectorMFDs[j][0] == w ) mfd = j;
			}
			var m = null;
			if( mfd > -1) m = h.$HUDSelectorMFDs[mfd][1]; //MFD name
			if( !m ) m = w; //mfd name is equal with worldScript name
			if(m && worldScripts[w]) player.ship.setMultiFunctionDisplay(i, m);
//			log(h.name, i+". MFD: "+w+" "+m+" "+worldScripts[w]);//debug
		}
	}
}

this.$HUDSelector_FCB = function( delta ) { //FrameCallBack for interface screen
	var h = worldScripts.hudselector;
	if( isValidFrameCallback( h.$HUDSelectorFCB ) ) removeFrameCallback( h.$HUDSelectorFCB );
	h.$HUDSelector_Interface();
}

this.$HUDSelector_FCB2 = function( delta ) { //FrameCallBack for interface screen
	var h = worldScripts.hudselector;
	if( isValidFrameCallback( h.$HUDSelectorFCB2 ) ) removeFrameCallback( h.$HUDSelectorFCB2 );
	h.$HUDSelector_InterfaceMFD();
}

this.$HUDSelector_Interface = function() {
	var h = worldScripts.hudselector;
	player.ship.hudHidden = false;
	h.$HUDSelectorSetHUD(h);
	var c = [];
	var title = "HUD selector";
	for( var j = 0; j < 20 && j < h.$HUDSelectorHUDs.length; j++ )
		c[ j ] = h.$HUDSelectorHUDs[j][0];
	var ch = {
			"_0" : "Go to MFD setup",
			"_10" : c[0],
		    	"_11" : c[1],
		    	"_12" : c[2],
		    	"_13" : c[3],
		    	"_14" : c[4],
		    	"_15" : c[5],
		    	"_16" : c[6],
		    	"_17" : c[7],
		    	"_18" : c[8],
		    	"_19" : c[9],
		    	"_20" : c[10],
		    	"_21" : c[11],
		    	"_22" : c[12],
		    	"_23" : c[13],
		    	"_24" : c[14],
		    	"_25" : c[15],
		    	"_26" : c[16],
		    	"_27" : c[17],
		    	"_28" : c[18],
		    	"_29" : c[19],
			"_E" : "Exit",
	};
	var ic = "_MFD";
	if( h.$HUDSelectorEqSel >= 0 && h.$HUDSelectorEqSel < 20 )
		ic = "_"+(10+h.$HUDSelectorEqSel);
	mission.runScreen({
			title: title,
			message: "",
//			background: "hudselector_bg.png",
//			model: "["+bgkey+"]",
			spinModel:false,
			initialChoicesKey: ic,
			choices: ch
	},function( choice ) {
			h.$HUDSelectorChoice = choice;
			if( choice == "_E" ) return;
			if( choice == "_0" ) {
				h.$HUDSelectorChoice = null;
				h.$HUDSelector_InterfaceMFD();
				return;
			}
			var t = -1;
			if( choice ) t = choice.substr(1) - 10; //cut starting "_"
//   			log(h.name, "MFD choice: "+choice+" "+t);//debug
			if(t >= 0 ) {
				h.$HUDSelectorEqSel = t;
				h.$HUDSelectorSetHUD(h);
			}
			if( !isValidFrameCallback( h.$HUDSelectorFCB ) )
				h.$HUDSelectorFCB = addFrameCallback( h.$HUDSelector_FCB );
	});
}

this.$HUDSelector_InterfaceMFD = function() {
	var h = worldScripts.hudselector;
	h.$MFDsetup = true;
	player.ship.hudHidden = true;
	var c = [];
	var title = "Default MFD selector";
	for( var j = 0; j < 24; j++ )
		c[ j ] = (j+1)+". MFD "+": "+(h.$HUDSelectorDefaultMFDs[j]);
	var ch = {
			"_0" : "Done",
			"_10" : c[0],
		    	"_11" : c[1],
		    	"_12" : c[2],
		    	"_13" : c[3],
		    	"_14" : c[4],
		    	"_15" : c[5],
		    	"_16" : c[6],
		    	"_17" : c[7],
		    	"_18" : c[8],
		    	"_19" : c[9],
		    	"_20" : c[10],
		    	"_21" : c[11],
		    	"_22" : c[12],
		    	"_23" : c[13],
		    	"_24" : c[14],
		    	"_25" : c[15],
		    	"_26" : c[16],
		    	"_27" : c[17],
		    	"_28" : c[18],
		    	"_29" : c[19],
		    	"_30" : c[20],
		    	"_31" : c[21],
		    	"_32" : c[22],
		    	"_33" : c[23]
	};
	var ic = "_10";
	if( h.$HUDSelectorChoice ) ic = h.$HUDSelectorChoice;
	mission.runScreen({
			title: title,
			message: "",
//			background: "hudselector_bg.png",
//			model: "["+bgkey+"]",
			spinModel:false,
			initialChoicesKey: ic,
			choices: ch
	},function( choice ) {
			h.$HUDSelectorChoice = choice;
			if( choice == "_0" ) return;
			var t = -1;
			if( choice ) t = choice.substr(1) - 10; //cut starting "_"
//   			log(h.name, "MFD choice: "+choice+" "+t);//debug
			if(t >= 0 ) {
				var m = h.$HUDSelectorDefaultMFDs[t];
				var mfd = -1;
				for(var i = 0; i < h.$HUDSelectorMFDs.length; i++) {
					if(h.$HUDSelectorMFDs[i] && m == h.$HUDSelectorMFDs[i][0])
						mfd = i + 1; //step to the next MFD
				}
				if( mfd == -1 || mfd >= h.$HUDSelectorMFDs.length ) mfd = 0;
				h.$HUDSelectorDefaultMFDs[t] = h.$HUDSelectorMFDs[mfd][0];
			}
			if( !isValidFrameCallback( h.$HUDSelectorFCB2 ) )
				h.$HUDSelectorFCB2 = addFrameCallback( h.$HUDSelector_FCB2 );
	});
}

